#include "functions.h"

float *	read_expression(string folder, string org_name, string data_type, map<string,unsigned int >::iterator crom, vector<string>::iterator strand,string elimit_string){

string dummy="dummy";
    string datafile;
	if(data_type=="Expression") datafile=folder+"/results/"+data_type+"_"+(*strand)+".wig";
	if(data_type=="Trans")  datafile=folder+"/results/"+data_type+"_"+(*strand)+"_"+elimit_string+".wig";

	ifstream  file,file2;
	string wigline="fixedStep chrom="+(*crom).first+" start=1 step=1";
	int START=0;
    int LEN=(*crom).second;
    float * exp=new float[LEN];

	file.open((datafile).c_str());

    if(!file){ cerr<<"File: "<<datafile<<"  doesn't exist"<<endl; exit(0);}
    else cout<<"File: "<<datafile<<"  exists"<<endl;
//    cout<<"search: "<<(*crom).first<<" "<<wigline<<endl;
	//// get to the crom line in multiple wig
    while (dummy.find((*crom).first)>1000000&&!file.eof()) {
        START++;
        getline(file,dummy);
//       cout<<"test: "<<START<<" "<<dummy<<" "<<dummy.find((*crom).first)<<endl; sleep(3);
    }
    if(!file.eof()){
         cout<<"Read expression profile for: "<<(*crom).first<<" at line: "<<START<<". Will read: "<<LEN<<" positions."<<endl;
        if((*strand)=="+"){
            for(int t=0; t<LEN; t++){
                file>>exp[t];
            }
        }

        if((*strand)=="-"){
            for(int t=0; t<LEN; t++){
                file>>exp[LEN-1-t];
            }
        }
        cout<<"Done reading expression."<<endl;
    }
    else {
     cout<<"Didn't find chromosome: "<<(*crom).first<<endl;
    }
	file.close();

	return exp;
}

float* compute_fold(float* exp1,float* exp2, size_t LEN,float elimit,float foldlimit,string folder,string org1, string org2,string strand,string crom,bool firstflag){
    float * fold=new float[LEN];
    float * proba=new float[LEN];
    ofstream file;
    for (unsigned int t=0;t<LEN;t++){
        fold[t]=(exp1[t]+elimit/foldlimit)/(exp2[t]+elimit/foldlimit);
        proba[t]=pow(2.7,2*(fold[t]-foldlimit));
        if(proba[t]>1)proba[t]=1;
        if (fold[t]<=1.1) proba[t]=0;
    }
//cout<<"test: "<<pow(2.7,5*(0.01))<<endl;sleep(10);
    if(firstflag) file.open((folder+"/"+org1+"_"+org2+"_fold_"+strand+".wig").c_str());
    else file.open((folder+"/"+org1+"_"+org2+"_fold_"+strand+".wig").c_str(),ios_base::app);
    file<<string("fixedStep chrom="+crom+" start=1  step=1")<<endl;
    if(strand=="+")
        for (unsigned int t=0; t<LEN;t++){        file<<fold[t]<<endl;        }
    if(strand=="-")
        for (unsigned int t=0; t<LEN;t++){        file<<fold[LEN-1-t]<<endl;        }
    file.close();

    if(firstflag) file.open((folder+"/"+org1+"_"+org2+"_proba_"+strand+".wig").c_str());
    else file.open((folder+"/"+org1+"_"+org2+"_proba_"+strand+".wig").c_str(),ios_base::app);
    file<<string("fixedStep chrom="+crom+" start=1  step=1")<<endl;
    if(strand=="+")
        for (unsigned int t=0; t<LEN;t++){        file<<proba[t]<<endl;        }
    if(strand=="-")
        for (unsigned int t=0; t<LEN;t++){        file<<proba[LEN-1-t]<<endl;}
    file.close();

 return proba;
}

map <string, unsigned int> get_chromosomes(string folder,string org_name){
    unsigned int length; string chr;
    map <string, unsigned int> chrs;

/**get chromosomes from chrom.sizes**/

	ifstream  file;
	file.open((folder+"/counts/"+org_name+".chrom.sizes").c_str());
	if(!file) {cerr<<".chrom.sizes not read; "<<(folder+"/counts/"+org_name+".chrom.sizes").c_str()<<" Probably the counts folder is wrong."<< endl; exit(1);}

	while ((file >> chr>>length).good()){
	    if(chr.find("_part_")>chr.length())
            chrs[chr]=length;
	}
	file.close();

	return chrs;

};


//
//
//vector< pair< pair<int,int>, float> > construct_regions(float * x,  int LEN, float penal,string folder,string data_type,string org1, string org2,string strand,string crom){
//
//    vector< pair< pair<int,int>, float> > pozs;
//    float score=0,cumul=0;
//    vector< pair< pair<int,int>, float> > ::iterator iterpozs;
//   	bool inside=0;
//   	float highscore=0;
//   	int high=0,startw=0;
//
//	for (int t=0;t<LEN;t++) {
//
//        if(inside==0) {
//            score=x[t]-penal;
//            if(score<= 0)
//                score=0;
//            else {
//                inside=1;
//                startw=t;
//                high=t;
//                highscore=score;
//            }
//        }
//
//        if(inside==1) {
//            score=score+x[t]-penal;
//            if(highscore<=score){highscore=score; high=t;}
//            if(score<=0){
//                for( int k=startw;k<high;k++)cumul+=x[k];
//                if(cumul>50)
//                    pozs.push_back(make_pair(make_pair(startw,high),cumul));
//
//                highscore=0;
//                inside=0;
//                cumul=0;
//
//            }
//        }
//    }
//
//
//    ofstream file;
//    if(org2!="NO") file.open((folder+"/"+org1+"_"+org2+"_"+data_type+"_"+strand+".bed").c_str());
//    if(org2=="NO") file.open((folder+"/"+org1+"_"+data_type+"_"+strand+".bed").c_str());
//
//    if(strand=="+")
//        for (iterpozs=pozs.begin(); iterpozs!=pozs.end();iterpozs++){
//            file<<crom<<" "<<1+((*iterpozs).first).first<<" "<<1+((*iterpozs).first).second<<" "<<strand<<" "<<(*iterpozs).second<<endl; }
//    if(strand=="-")
//        for (iterpozs=pozs.begin(); iterpozs!=pozs.end();iterpozs++){
//            file<<crom<<" "<<LEN-((*iterpozs).first).second<<" "<<LEN-((*iterpozs).first).first<<" "<<strand<<" "<<(*iterpozs).second<<endl; }
//    file.close();
//
//    return pozs;
//}
//



vector< pair< pair<int,int>, float> > construct_regions(float * x,  int LEN, float penal,string folder,string data_type,string org1, string org2,string strand,string crom,bool firstflag){

    vector< pair< pair<int,int>, float> > pozs;
    float probalimit=0.5;
    float score=0,cumul=0;
    vector< pair< pair<int,int>, float> > ::iterator iterpozs;
   	bool inside=0;
   	float highscore=0;
   	int high=0,startw=0;

	for (int t=0;t<LEN;t++) {

        if(inside==0) {
            score=x[t]-penal;
            if(x[t]<=probalimit) score=0;
            else {
                inside=1;
                startw=t;
                high=t;
                highscore=score;
            }
        }

        if(inside==1) {
            score=score+x[t]-penal;
            score=score>1?1:score;
            if(highscore<=score){highscore=score; high=t;}
            if(score<=0){
                for( int k=startw;k<high;k++)cumul+=x[k]; cumul=cumul/(high-startw);
                if(cumul>probalimit&&(high-startw>=100))
                    pozs.push_back(make_pair(make_pair(startw,high),cumul));

                highscore=0;
                inside=0;
                cumul=0;
                t=high;

            }
        }
    }


    ofstream file;
    if(firstflag){
        if(org2!="NO") file.open((folder+"/"+org1+"_"+org2+"_"+data_type+"_"+strand+".bed").c_str());
        if(org2=="NO") file.open((folder+"/"+org1+"_"+data_type+"_"+strand+".bed").c_str());}
    else {
        if(org2!="NO") file.open((folder+"/"+org1+"_"+org2+"_"+data_type+"_"+strand+".bed").c_str(),ios_base::app);
        if(org2=="NO") file.open((folder+"/"+org1+"_"+data_type+"_"+strand+".bed").c_str(),ios_base::app);
    }

    if(strand=="+")
        for (iterpozs=pozs.begin(); iterpozs!=pozs.end();iterpozs++){
            file<<crom<<" "<<1+((*iterpozs).first).first<<" "<<1+((*iterpozs).first).second<<" "<<floor(100.0*(*iterpozs).second)/100.0<<" "<<strand<<endl; }
    if(strand=="-")
        for (iterpozs=pozs.begin(); iterpozs!=pozs.end();iterpozs++){
            file<<crom<<" "<<LEN-((*iterpozs).first).second<<" "<<LEN-((*iterpozs).first).first<<" "<<floor(100.0*(*iterpozs).second)/100.0<<" "<<strand<<endl; }
    file.close();
cout<<"closed: "<<file<<endl;
    return pozs;
}

